Index: issm/trunk/src/c/classes/Materials/Matpar.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matpar.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Matpar.cpp	(revision 18301)
@@ -13,11 +13,9 @@
 
 /*Matpar constructors and destructor*/
-/*FUNCTION Matpar::Matpar() {{{*/
-Matpar::Matpar(){
+Matpar::Matpar(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION Matpar::Matpar(int matpar_mid,IoModel* iomodel){{{*/
-Matpar::Matpar(int matpar_mid, IoModel* iomodel){
+Matpar::Matpar(int matpar_mid, IoModel* iomodel){/*{{{*/
 
 	bool isefficientlayer;
@@ -56,4 +54,10 @@
 			/*Nothing to add*/
 			break;
+		case SMBcomponentsEnum:
+			/*Nothing to add*/
+			break;
+		case SMBmeltcomponentsEnum:
+			/*Nothing to add*/
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
@@ -88,6 +92,5 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::~Matpar() {{{*/
-Matpar::~Matpar(){
+Matpar::~Matpar(){/*{{{*/
 	return;
 }
@@ -95,6 +98,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Matpar::Echo {{{*/
-void Matpar::Echo(void){
+void Matpar::Echo(void){/*{{{*/
 
 	_printf_("Matpar:\n");
@@ -119,15 +121,12 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::DeepEcho {{{*/
-void Matpar::DeepEcho(void){
+void Matpar::DeepEcho(void){/*{{{*/
 
 	this->Echo();
 }		
 /*}}}*/
-/*FUNCTION Matpar::Id {{{*/
-int    Matpar::Id(void){ return mid; }
-/*}}}*/
-/*FUNCTION Matpar::ObjectEnum{{{*/
-int Matpar::ObjectEnum(void){
+int    Matpar::Id(void){ return mid; }/*{{{*/
+/*}}}*/
+int Matpar::ObjectEnum(void){/*{{{*/
 
 	return MatparEnum;
@@ -135,28 +134,65 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::copy {{{*/
-Object* Matpar::copy() {
-	return new Matpar(*this); 
+Object* Matpar::copy() {/*{{{*/
+
+	/*Output*/
+	Matpar* matpar;
+
+	/*Initialize output*/
+	matpar=new Matpar(*this);
+
+	/*copy fields: */
+	matpar->mid=this->mid;
+	matpar->rho_ice=this->rho_ice;
+	matpar->rho_water=this->rho_water;
+	matpar->rho_freshwater=this->rho_freshwater;
+	matpar->mu_water=this->mu_water;
+	matpar->heatcapacity=this->heatcapacity;
+	matpar->thermalconductivity=this->thermalconductivity;
+	matpar->temperateiceconductivity=this->temperateiceconductivity;
+	matpar->latentheat=this->latentheat;
+	matpar->beta=this->beta;
+	matpar->meltingpoint=this->meltingpoint;
+	matpar->referencetemperature=this->referencetemperature;
+	matpar->mixed_layer_capacity=this->mixed_layer_capacity;
+	matpar->thermal_exchange_velocity=this->thermal_exchange_velocity;
+	matpar->g=this->g;
+	matpar->desfac=this->desfac;
+	matpar->s0p=this->s0p;
+
+	matpar->sediment_compressibility=this->sediment_compressibility;
+	matpar->sediment_porosity=this->sediment_porosity;
+	matpar->sediment_thickness=this->sediment_thickness;
+	matpar->water_compressibility=this->water_compressibility;
+
+	matpar->epl_compressibility=this->epl_compressibility;
+	matpar->epl_porosity=this->epl_porosity;
+	matpar->epl_init_thickness=this->epl_init_thickness;
+	matpar->epl_max_thickness=this->epl_max_thickness;
+	matpar->epl_conductivity=this->epl_conductivity;
+
+	matpar->lithosphere_shear_modulus=this->lithosphere_shear_modulus;
+	matpar->lithosphere_density=this->lithosphere_density;
+	matpar->mantle_shear_modulus=this->mantle_shear_modulus;
+	matpar->mantle_density=this->mantle_density;
+
+	return matpar;
 }
 /*}}}*/
 
 /*Update virtual functions definitions:*/
-/*FUNCTION Matpar::InputUpdateFromVector(IssmDouble* vector, int name, int type) {{{*/
-void   Matpar::InputUpdateFromVector(IssmDouble* vector, int name, int type){
+void   Matpar::InputUpdateFromVector(IssmDouble* vector, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matpar::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type) {{{*/
-void   Matpar::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){
+void   Matpar::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matpar::InputUpdateFromMatrixDakota(IssmDouble* vector, int name, int type) {{{*/
-void  Matpar::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols,int name, int type){
+void  Matpar::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols,int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matpar::InputUpdateFromConstant(IssmDouble constant, int name) {{{*/
-void   Matpar::InputUpdateFromConstant(IssmDouble constant, int name){
+void   Matpar::InputUpdateFromConstant(IssmDouble constant, int name){/*{{{*/
 
 	switch(name){
@@ -215,11 +251,9 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::InputUpdateFromConstant(int constant, int name) {{{*/
-void   Matpar::InputUpdateFromConstant(int constant, int name){
+void   Matpar::InputUpdateFromConstant(int constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matpar::InputUpdateFromConstant(bool constant, int name) {{{*/
-void   Matpar::InputUpdateFromConstant(bool constant, int name){
+void   Matpar::InputUpdateFromConstant(bool constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
@@ -227,6 +261,5 @@
 
 /*Matpar management: */
-/*FUNCTION Matpar::Configure {{{*/
-void  Matpar::Configure(Elements* elementsin){
+void  Matpar::Configure(Elements* elementsin){/*{{{*/
 
 	/*nothing done yet!*/
@@ -234,6 +267,5 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::Configure {{{*/
-IssmDouble Matpar::GetMaterialParameter(int enum_in){
+IssmDouble Matpar::GetMaterialParameter(int enum_in){/*{{{*/
 
 	switch(enum_in){
@@ -266,57 +298,46 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::GetBeta {{{*/
-IssmDouble Matpar::GetBeta(){
+IssmDouble Matpar::GetBeta(){/*{{{*/
 	return beta;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetG {{{*/
-IssmDouble Matpar::GetG(){
+IssmDouble Matpar::GetG(){/*{{{*/
 	return g;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetMeltingPoint {{{*/
-IssmDouble Matpar::GetMeltingPoint(){
+IssmDouble Matpar::GetMeltingPoint(){/*{{{*/
 	return meltingpoint;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetRhoIce {{{*/
-IssmDouble Matpar::GetRhoIce(){
+IssmDouble Matpar::GetRhoIce(){/*{{{*/
 
 	return rho_ice;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetRhoWater {{{*/
-IssmDouble Matpar::GetRhoWater(){
+IssmDouble Matpar::GetRhoWater(){/*{{{*/
 	return rho_water;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetRhoFreshwater {{{*/
-IssmDouble Matpar::GetRhoFreshwater(){
+IssmDouble Matpar::GetRhoFreshwater(){/*{{{*/
 	return rho_freshwater;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetDesFac {{{*/
-IssmDouble Matpar::GetDesFac(){
+IssmDouble Matpar::GetDesFac(){/*{{{*/
 	return desfac;
 }
 /*}}}*/
-/*FUNCTION Matpar::GetS0p {{{*/
-IssmDouble Matpar::GetS0p(){
+IssmDouble Matpar::GetS0p(){/*{{{*/
 	return s0p;
 }
 /*}}}*/
-/*FUNCTION Matpar::TMeltingPoint {{{*/
-IssmDouble Matpar::TMeltingPoint(IssmDouble pressure){
+IssmDouble Matpar::TMeltingPoint(IssmDouble pressure){/*{{{*/
 	return meltingpoint-beta*pressure;
 }
 /*}}}*/
-/*FUNCTION Matpar::PureIceEnthalpy{{{*/
-IssmDouble Matpar::PureIceEnthalpy(IssmDouble pressure){
+IssmDouble Matpar::PureIceEnthalpy(IssmDouble pressure){/*{{{*/
 	return heatcapacity*(TMeltingPoint(pressure)-referencetemperature);
 }
 /*}}}*/
-/*FUNCTION Matpar::GetEnthalpyDiffusionParameter{{{*/
-IssmDouble Matpar::GetEnthalpyDiffusionParameter(IssmDouble enthalpy,IssmDouble pressure){
+IssmDouble Matpar::GetEnthalpyDiffusionParameter(IssmDouble enthalpy,IssmDouble pressure){/*{{{*/
 	if (enthalpy<PureIceEnthalpy(pressure))
 		return thermalconductivity/heatcapacity;
@@ -325,6 +346,5 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::GetEnthalpyDiffusionParameterVolume{{{*/
-IssmDouble Matpar::GetEnthalpyDiffusionParameterVolume(int numvertices,IssmDouble* enthalpy,IssmDouble* pressure){
+IssmDouble Matpar::GetEnthalpyDiffusionParameterVolume(int numvertices,IssmDouble* enthalpy,IssmDouble* pressure){/*{{{*/
 
 	int         iv;
@@ -372,6 +392,5 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::EnthalpyToThermal {{{*/
-void Matpar::EnthalpyToThermal(IssmDouble* ptemperature,IssmDouble* pwaterfraction,IssmDouble enthalpy,IssmDouble pressure){
+void Matpar::EnthalpyToThermal(IssmDouble* ptemperature,IssmDouble* pwaterfraction,IssmDouble enthalpy,IssmDouble pressure){/*{{{*/
 
 	/*Ouput*/
@@ -392,6 +411,5 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::ThermalToEnthalpy {{{*/
-void Matpar::ThermalToEnthalpy(IssmDouble * penthalpy,IssmDouble temperature,IssmDouble waterfraction,IssmDouble pressure){
+void Matpar::ThermalToEnthalpy(IssmDouble * penthalpy,IssmDouble temperature,IssmDouble waterfraction,IssmDouble pressure){/*{{{*/
 
 	/*Ouput*/
@@ -409,22 +427,24 @@
 }
 /*}}}*/
-/*FUNCTION Matpar::GetLithosphereShearModulus {{{*/			 
-IssmDouble Matpar::GetLithosphereShearModulus(){		 
+IssmDouble Matpar::GetLithosphereShearModulus(){		 /*{{{*/
 	return lithosphere_shear_modulus;			 
 }		 
 /*}}}*/ 
-/*FUNCTION Matpar::GetLithosphereDensity {{{*/			 
-IssmDouble Matpar::GetLithosphereDensity(){		 
+IssmDouble Matpar::GetLithosphereDensity(){		 /*{{{*/
 	return lithosphere_density;			 
 }		 
 /*}}}*/ 
-/*FUNCTION Matpar::GetMantleDensity {{{*/			 
-IssmDouble Matpar::GetMantleDensity(){		 
+IssmDouble Matpar::GetMantleDensity(){		 /*{{{*/
 	return mantle_density;			 
 }		 
 /*}}}*/ 
-/*FUNCTION Matpar::GetMantleShearModulus {{{*/			 
-IssmDouble Matpar::GetMantleShearModulus(){		 
+IssmDouble Matpar::GetMantleShearModulus(){		 /*{{{*/
 	return mantle_shear_modulus;			 
 }		 
 /*}}}*/ 
+void  Matpar::ResetHooks(){/*{{{*/
+
+	//Nothing to be done
+	return;
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Materials/Matpar.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Matpar.h	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Matpar.h	(revision 18301)
@@ -76,4 +76,6 @@
 		void       Configure(Elements* elements);
 		void       GetViscosity(IssmDouble* pviscosity,IssmDouble eps_eff){_error_("not supported");};
+		void       GetViscosity_B(IssmDouble* pviscosity,IssmDouble eps_eff){_error_("not supported");};
+		void       GetViscosity_D(IssmDouble* pviscosity,IssmDouble eps_eff){_error_("not supported");};
 		void       GetViscosityBar(IssmDouble* pviscosity,IssmDouble eps_eff){_error_("not supported");};
 		void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon){_error_("not supported");};
@@ -89,4 +91,5 @@
 		IssmDouble GetDbar(){_error_("not supported");};
 		bool       IsDamage(){_error_("not supported");};
+		void       ResetHooks();
 		/*}}}*/
 		/*Numerics: {{{*/
Index: issm/trunk/src/c/classes/Misfit.h
===================================================================
--- issm/trunk/src/c/classes/Misfit.h	(revision 18081)
+++ issm/trunk/src/c/classes/Misfit.h	(revision 18301)
@@ -31,6 +31,5 @@
 		
 		/*Misfit constructors, destructors :*/
-		/*FUNCTION Misfit() {{{*/
-		Misfit(){
+		Misfit(){/*{{{*/
 
 			this->name = NULL;
@@ -44,6 +43,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION Misfit(char* in_name, int in_model_enum, int in_observation_enum char* in_timeinterpolation, int in_weights_enum) {{{*/
-		Misfit(char* in_name, int in_model_enum, int in_observation_enum, char* in_timeinterpolation, int in_weights_enum){
+		Misfit(char* in_name, int in_model_enum, int in_observation_enum, char* in_timeinterpolation, int in_weights_enum){/*{{{*/
 
 			this->name   = xNew<char>(strlen(in_name)+1);
@@ -61,6 +59,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION ~Misfit() {{{*/
-		~Misfit(){
+		~Misfit(){/*{{{*/
 			if(this->name)xDelete(this->name);
 			if(this->timeinterpolation)xDelete(this->timeinterpolation);
@@ -70,6 +67,5 @@
 		/*}}}*/
 		/*Object virtual function resolutoin: */
-		/*FUNCTION Echo(){{{*/
-		void Echo(void){
+		void Echo(void){/*{{{*/
 			_printf_(" Misfit: " << name << "\n");
 			_printf_("    model_enum: " << model_enum << " " << EnumToStringx(model_enum) << "\n");
@@ -79,27 +75,25 @@
 		}
 		/*}}}*/
-		/*FUNCTION DeepEcho(){{{*/
-		void DeepEcho(void){
+		void DeepEcho(void){/*{{{*/
 			this->Echo();
 		}
 		/*}}}*/
-		/*FUNCTION Id(){{{*/
-		int Id(void){
+		int Id(void){/*{{{*/
 			return -1;
 		}
 		/*}}}*/
-		/*FUNCTION ObjectEnum{{{*/
-		int ObjectEnum(void){
+		int ObjectEnum(void){/*{{{*/
 			return MisfitEnum;
 		}
 		/*}}}*/
-		/*FUNCTION copy {{{*/
-		Object* copy() {
-			return new Misfit(this->name,this->model_enum,this->observation_enum,this->timeinterpolation,this->weights_enum);
+		Object* copy() {/*{{{*/
+			Misfit* mf = new Misfit(this->name,this->model_enum,this->observation_enum,this->timeinterpolation,this->weights_enum);
+			mf->misfit=this->misfit;
+			mf->lock=this->lock;
+			return (Object*) mf;
 		}
 		/*}}}*/
 		/*Definition virtual function resolutoin: */
-		/*FUNCTION char* Name() {{{*/
-		char* Name(){
+		char* Name(){/*{{{*/
 
 			char* name2=xNew<char>(strlen(this->name)+1);
@@ -109,6 +103,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION IssmDouble Response(FemModel* femmodel) {{{*/
-		 IssmDouble Response(FemModel* femmodel){
+		 IssmDouble Response(FemModel* femmodel){/*{{{*/
 
 			 int i;
Index: issm/trunk/src/c/classes/Node.cpp
===================================================================
--- issm/trunk/src/c/classes/Node.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Node.cpp	(revision 18301)
@@ -17,11 +17,9 @@
 
 /*Node constructors and destructors:*/
-/*FUNCTION Node::Node() default constructor {{{*/
-Node::Node(){
+Node::Node(){/*{{{*/
 	this->approximation=0;
 }
 /*}}}*/
-/*FUNCTION Node::Node(int node_id,int node_sid,int node_lid,int io_index, IoModel* iomodel,int analysis_enum,int approximation) {{{*/
-Node::Node(int node_id,int node_sid,int node_lid,int io_index, IoModel* iomodel,int analysis_enum,int in_approximation){
+Node::Node(int node_id,int node_sid,int node_lid,int io_index, IoModel* iomodel,int analysis_enum,int in_approximation){/*{{{*/
 
 	/*Intermediary*/
@@ -123,13 +121,38 @@
 }
 /*}}}*/
-/*FUNCTION Node::~Node(){{{*/
-Node::~Node(){
+Node::~Node(){/*{{{*/
 	return;
 }
 /*}}}*/
+Object* Node::copy(void){/*{{{*/
+
+	int k,l;
+
+	/*output: */
+	Node* output=NULL;
+
+	/*initalize output: */
+	output=new Node();
+
+	/*id: */
+	output->id  = this->id;
+	output->sid = this->sid;
+	output->lid = this->lid;
+	output->analysis_enum = this->analysis_enum;
+	output->approximation = this->approximation;
+
+	/*Initialize coord_system: */
+	for(k=0;k<3;k++) for(l=0;l<3;l++) output->coord_system[k][l]=this->coord_system[k][l];
+
+	/*indexing:*/
+	output->indexingupdate = this->indexingupdate;
+	output->indexing.copy(this->indexing);
+
+	return (Object*)output; 
+}
+/*}}}*/
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Node::Echo{{{*/
-void Node::Echo(void){
+void Node::Echo(void){/*{{{*/
 
 	_printf_("Node:\n");
@@ -143,6 +166,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::DeepEcho{{{*/
-void Node::DeepEcho(void){
+void Node::DeepEcho(void){/*{{{*/
 
 	_printf_("Node:\n");
@@ -156,9 +178,7 @@
 }
 /*}}}*/
-/*FUNCTION Node::Id{{{*/
-int    Node::Id(void){ return id; }
-/*}}}*/
-/*FUNCTION Node::ObjectEnum{{{*/
-int Node::ObjectEnum(void){
+int  Node::Id(void){ return id; }/*{{{*/
+/*}}}*/
+int  Node::ObjectEnum(void){/*{{{*/
 
 	return NodeEnum;
@@ -168,6 +188,5 @@
 
 /*Node management:*/
-/*FUNCTION Node::GetDof {{{*/
-int   Node::GetDof(int dofindex,int setenum){
+int  Node::GetDof(int dofindex,int setenum){/*{{{*/
 
 	_assert_(!this->indexingupdate);
@@ -187,6 +206,5 @@
 
 } /*}}}*/
-/*FUNCTION Node::GetDofList{{{*/
-void  Node::GetDofList(int* outdoflist,int approximation_enum,int setenum){
+void Node::GetDofList(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
 	int i;
 	int count=0;
@@ -251,6 +269,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::GetLocalDofList{{{*/
-void  Node::GetLocalDofList(int* outdoflist,int approximation_enum,int setenum){
+void Node::GetLocalDofList(int* outdoflist,int approximation_enum,int setenum){/*{{{*/
 	int i;
 	int count=0;
@@ -352,16 +369,13 @@
 }
 /*}}}*/
-/*FUNCTION Node::Sid{{{*/
-int Node::Sid(void){
+int  Node::Sid(void){/*{{{*/
 	return sid; 
 }
 /*}}}*/
-/*FUNCTION Node::Lid{{{*/
-int  Node::Lid(void){
+int  Node::Lid(void){/*{{{*/
 	return lid; 
 }
 /*}}}*/
-/*FUNCTION Node::GetCoordinateSystem{{{*/
-void Node::GetCoordinateSystem(IssmDouble* coord_system_out){
+void Node::GetCoordinateSystem(IssmDouble* coord_system_out){/*{{{*/
 
 	/*Copy coord_system*/
@@ -370,6 +384,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::InAnalysis{{{*/
-bool Node::InAnalysis(int in_analysis_enum){
+bool Node::InAnalysis(int in_analysis_enum){/*{{{*/
 	if (in_analysis_enum==this->analysis_enum) return true;
 	else return false;
@@ -378,6 +391,5 @@
 
 /*Node numerics:*/
-/*FUNCTION Node::ApplyConstraints{{{*/
-void  Node::ApplyConstraint(int dof,IssmDouble value){
+void Node::ApplyConstraint(int dof,IssmDouble value){/*{{{*/
 
 	/*Dof should be added in the s set, describing which 
@@ -387,6 +399,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::RequiresDofReindexing{{{*/
-bool Node::RequiresDofReindexing(void){
+bool Node::RequiresDofReindexing(void){/*{{{*/
 
 	return this->indexingupdate;
@@ -394,6 +405,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::ReindexingDone{{{*/
-void Node::ReindexingDone(void){
+void Node::ReindexingDone(void){/*{{{*/
 
 	this->indexingupdate = false;
@@ -401,6 +411,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::RelaxConstraint{{{*/
-void  Node::RelaxConstraint(int dof){
+void Node::RelaxConstraint(int dof){/*{{{*/
 
 	/*Dof should be added to the f-set, and taken out of the s-set:*/
@@ -409,6 +418,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::CreateNodalConstraints{{{*/
-void  Node::CreateNodalConstraints(Vector<IssmDouble>* ys){
+void Node::CreateNodalConstraints(Vector<IssmDouble>* ys){/*{{{*/
 
 	int i;
@@ -437,6 +445,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::DofInSSet {{{*/
-void  Node::DofInSSet(int dof){
+void Node::DofInSSet(int dof){/*{{{*/
 
 	/*Put dof for this node into the s set (ie, this dof will be constrained 
@@ -451,6 +458,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::DofInFSet {{{*/
-void  Node::DofInFSet(int dof){
+void Node::DofInFSet(int dof){/*{{{*/
 
 	/*Put dof for this node into the f set (ie, this dof will NOT be constrained 
@@ -465,6 +471,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::FreezeDof{{{*/
-void  Node::FreezeDof(int dof){
+void Node::FreezeDof(int dof){/*{{{*/
 
 	DofInSSet(dof); //with 0 displacement for this dof.
@@ -472,6 +477,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::Deactivate{{{*/
-void  Node::Deactivate(void){
+void Node::Deactivate(void){/*{{{*/
 
 	if(IsActive()){
@@ -482,6 +486,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::Activate{{{*/
-void  Node::Activate(void){
+void Node::Activate(void){/*{{{*/
 
 	if(!IsActive()){
@@ -492,6 +495,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::IsActive{{{*/
-bool Node::IsActive(void){
+bool Node::IsActive(void){/*{{{*/
 
 	return indexing.active;
@@ -499,12 +501,10 @@
 }
 /*}}}*/
-/*FUNCTION Node::GetApproximation {{{*/
-int   Node::GetApproximation(){
+int  Node::GetApproximation(){/*{{{*/
 
 	return approximation;
 }
 /*}}}*/
-/*FUNCTION Node::GetNumberOfDofs{{{*/
-int   Node::GetNumberOfDofs(int approximation_enum,int setenum){
+int  Node::GetNumberOfDofs(int approximation_enum,int setenum){/*{{{*/
 
 	/*Get number of degrees of freedom in a node, for a certain set (g,f or s-set)
@@ -541,5 +541,5 @@
 		else if (setenum==SsetEnum){
 			if(this->indexing.doftype){
-				numdofs=0;
+			numdofs=0;
 				for(i=0;i<this->indexing.gsize;i++){
 					if((this->indexing.doftype[i]==approximation_enum) && (this->indexing.s_set[i])) numdofs++;
@@ -553,6 +553,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::IsClone {{{*/
-int   Node::IsClone(){
+int  Node::IsClone(){/*{{{*/
 
 	return indexing.clone;
@@ -560,6 +559,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::VecMerge {{{*/
-void Node::VecMerge(Vector<IssmDouble>* ug, IssmDouble* vector_serial,int setenum){
+void Node::VecMerge(Vector<IssmDouble>* ug, IssmDouble* vector_serial,int setenum){/*{{{*/
 
 	IssmDouble *values  = NULL;
@@ -611,6 +609,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::VecReduce {{{*/
-void   Node::VecReduce(Vector<IssmDouble>* vector, IssmDouble* ug_serial,int setenum){
+void Node::VecReduce(Vector<IssmDouble>* vector, IssmDouble* ug_serial,int setenum){/*{{{*/
 
 	IssmDouble* values=NULL;
@@ -658,6 +655,5 @@
 
 /* indexing routines:*/
-/*FUNCTION Node::DistributeDofs{{{*/
-void  Node::DistributeDofs(int* pdofcount,int setenum){
+void Node::DistributeDofs(int* pdofcount,int setenum){/*{{{*/
 
 	int i;
@@ -700,6 +696,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::OffsetDofs{{{*/
-void  Node::OffsetDofs(int dofcount,int setenum){
+void Node::OffsetDofs(int dofcount,int setenum){/*{{{*/
 
 	int i;
@@ -723,6 +718,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::ShowTrueDofs{{{*/
-void  Node::ShowTrueDofs(int* truedofs, int ncols,int setenum){
+void Node::ShowTrueDofs(int* truedofs, int ncols,int setenum){/*{{{*/
 
 	int j;
@@ -748,6 +742,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::UpdateCloneDofs{{{*/
-void  Node::UpdateCloneDofs(int* alltruedofs,int ncols,int setenum){
+void Node::UpdateCloneDofs(int* alltruedofs,int ncols,int setenum){/*{{{*/
 
 	int j;
@@ -773,6 +766,5 @@
 }
 /*}}}*/
-/*FUNCTION Node::SetClone {{{*/
-void  Node::SetClone(int* minranks){
+void Node::SetClone(int* minranks){/*{{{*/
 
 	int my_rank;
Index: issm/trunk/src/c/classes/Node.h
===================================================================
--- issm/trunk/src/c/classes/Node.h	(revision 18081)
+++ issm/trunk/src/c/classes/Node.h	(revision 18301)
@@ -49,5 +49,5 @@
 		int     Id();
 		int     ObjectEnum();
-		Object *copy(){_error_("Not implemented yet (similar to Elements)"); };
+		Object *copy();
 
 		/*Node numerical routines*/
Index: issm/trunk/src/c/classes/Nodes.cpp
===================================================================
--- issm/trunk/src/c/classes/Nodes.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Nodes.cpp	(revision 18301)
@@ -19,12 +19,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Nodes::Nodes(){{{*/
-Nodes::Nodes(){
+Nodes::Nodes(){/*{{{*/
 	enum_type=NodesEnum;
 	return;
 }
 /*}}}*/
-/*FUNCTION Nodes::~Nodes(){{{*/
-Nodes::~Nodes(){
+Nodes::~Nodes(){/*{{{*/
 	return;
 }
@@ -32,6 +30,5 @@
 
 /*Numerics*/
-/*FUNCTION Nodes::DistributeDofs{{{*/
-void  Nodes::DistributeDofs(int analysis_type,int setenum){
+void  Nodes::DistributeDofs(int analysis_type,int setenum){/*{{{*/
 
 	int  i;
@@ -122,6 +119,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::FlagClones{{{*/
-void  Nodes::FlagClones(int analysis_type){
+void  Nodes::FlagClones(int analysis_type){/*{{{*/
 
 	int i;
@@ -168,6 +164,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::MaxNumDofs{{{*/
-int   Nodes::MaxNumDofs(int analysis_type,int setenum){
+int   Nodes::MaxNumDofs(int analysis_type,int setenum){/*{{{*/
 
 	int max=0;
@@ -194,6 +189,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::MaximymId{{{*/
-int Nodes::MaximumId(){
+int   Nodes::MaximumId(){/*{{{*/
 
 	int max=-1;
@@ -225,6 +219,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfDofs{{{*/
-int   Nodes::NumberOfDofs(int analysis_type,int setenum){
+int   Nodes::NumberOfDofs(int analysis_type,int setenum){/*{{{*/
 
 	int   allnumdofs;
@@ -238,6 +231,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfDofsLocal{{{*/
-int   Nodes::NumberOfDofsLocal(int analysis_type,int setenum){
+int   Nodes::NumberOfDofsLocal(int analysis_type,int setenum){/*{{{*/
 
 	int   numdofs=0;
@@ -261,6 +253,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfNodes(){{{*/
-int Nodes::NumberOfNodes(void){
+int   Nodes::NumberOfNodes(void){/*{{{*/
 
 	/*Careful! only use once all clones have been setup for all nodes!: */
@@ -283,6 +274,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::NumberOfNodes(analysis){{{*/
-int Nodes::NumberOfNodes(int analysis_type){
+int   Nodes::NumberOfNodes(int analysis_type){/*{{{*/
 
 	int i;
@@ -315,6 +305,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::Ranks{{{*/
-void   Nodes::Ranks(int* ranks,int analysis_type){
+void  Nodes::Ranks(int* ranks,int analysis_type){/*{{{*/
 
 	int my_rank;
@@ -338,6 +327,5 @@
 }
 /*}}}*/
-/*FUNCTION Nodes::RequiresDofReindexing{{{*/
-bool Nodes::RequiresDofReindexing(int analysis_type){
+bool Nodes::RequiresDofReindexing(int analysis_type){/*{{{*/
 
 	int flag = 0;
Index: issm/trunk/src/c/classes/Options/OptionUtilities.cpp
===================================================================
--- issm/trunk/src/c/classes/Options/OptionUtilities.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Options/OptionUtilities.cpp	(revision 18301)
@@ -15,6 +15,5 @@
 /*}}}*/
 
-/*FUNCTION ColumnWiseDimsFromIndex{{{*/
-int ColumnWiseDimsFromIndex(int* dims,int index,int* size,int ndims){
+int ColumnWiseDimsFromIndex(int* dims,int index,int* size,int ndims){/*{{{*/
 
 	int   i;
@@ -34,6 +33,5 @@
 	return(0);
 }/*}}}*/
-/*FUNCTION IndexFromColumnWiseDims{{{*/
-int IndexFromColumnWiseDims(int* dims, int* size, int ndims) {
+int IndexFromColumnWiseDims(int* dims, int* size, int ndims) {/*{{{*/
 
 	int   i;
@@ -53,6 +51,5 @@
 	return(index);
 }/*}}}*/
-/*FUNCTION RowWiseDimsFromIndex{{{*/
-int RowWiseDimsFromIndex(int* dims, int index, int* size, int ndims) {
+int RowWiseDimsFromIndex(int* dims, int index, int* size, int ndims) {/*{{{*/
 
 	int   i;
@@ -72,6 +69,5 @@
 	return(0);
 }/*}}}*/
-/*FUNCTION IndexFromRowWiseDims{{{*/
-int IndexFromRowWiseDims(int* dims, int* size, int ndims) {
+int IndexFromRowWiseDims(int* dims, int* size, int ndims) {/*{{{*/
 
 	int   i;
@@ -91,6 +87,5 @@
 	return(index);
 }/*}}}*/
-/*FUNCTION StringFromDims{{{*/
-int StringFromDims(char* cstr, int* dims, int ndims) {
+int StringFromDims(char* cstr, int* dims, int ndims) {/*{{{*/
 
 	sprintf(&cstr[0],"[");
@@ -100,6 +95,5 @@
 	return(0);
 }/*}}}*/
-/*FUNCTION StringFromSize{{{*/
-int StringFromSize(char* cstr, int* size, int ndims) {
+int StringFromSize(char* cstr, int* size, int ndims) {/*{{{*/
 
 	sprintf(&cstr[0],"[");
Index: issm/trunk/src/c/classes/Options/Options.cpp
===================================================================
--- issm/trunk/src/c/classes/Options/Options.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Options/Options.cpp	(revision 18301)
@@ -21,11 +21,9 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Options::Options(){{{*/
-Options::Options(){
+Options::Options(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION Options::~Options(){{{*/
-Options::~Options(){
+Options::~Options(){/*{{{*/
 	return;
 }
@@ -33,6 +31,5 @@
 
 /*Object management*/
-/*FUNCTION Options::AddOption{{{*/
-int  Options::AddOption(Option* in_option){
+int  Options::AddOption(Option* in_option){/*{{{*/
 
 	char* name=NULL;
@@ -68,6 +65,5 @@
 }
 /*}}}*/
-/*FUNCTION Options::GetOption{{{*/
-Option* Options::GetOption(const char* name){
+Option* Options::GetOption(const char* name){/*{{{*/
 
 	vector<Object*>::iterator object;
Index: issm/trunk/src/c/classes/Params/BoolParam.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/BoolParam.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Params/BoolParam.cpp	(revision 18301)
@@ -16,11 +16,9 @@
 
 /*BoolParam constructors and destructor*/
-/*FUNCTION BoolParam::BoolParam(){{{*/
-BoolParam::BoolParam(){
+BoolParam::BoolParam(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION BoolParam::BoolParam(int enum_type,bool value){{{*/
-BoolParam::BoolParam(int in_enum_type,bool in_value){
+BoolParam::BoolParam(int in_enum_type,bool in_value){/*{{{*/
 
 	enum_type=in_enum_type;
@@ -28,6 +26,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolParam::~BoolParam(){{{*/
-BoolParam::~BoolParam(){
+BoolParam::~BoolParam(){/*{{{*/
 	return;
 }
@@ -35,19 +32,15 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION BoolParam::Echo {{{*/
-void BoolParam::Echo(void){
+void BoolParam::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION BoolParam::DeepEcho{{{*/
-void BoolParam::DeepEcho(void){
+void BoolParam::DeepEcho(void){/*{{{*/
 	_printf_(setw(22)<<"   BoolParam "<<setw(35)<<left<<EnumToStringx(this->enum_type)<<" "<<(value?"true":"false")<<"\n");
 }
 /*}}}*/
-/*FUNCTION BoolParam::Id{{{*/
-int    BoolParam::Id(void){ return -1; }
+int    BoolParam::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION BoolParam::ObjectEnum{{{*/
-int BoolParam::ObjectEnum(void){
+int BoolParam::ObjectEnum(void){/*{{{*/
 
 	return BoolParamEnum;
@@ -55,6 +48,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolParam::copy{{{*/
-Object* BoolParam::copy() {
+Object* BoolParam::copy() {/*{{{*/
 
 	return new BoolParam(this->enum_type,this->value);
Index: issm/trunk/src/c/classes/Params/DataSetParam.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/DataSetParam.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Params/DataSetParam.cpp	(revision 18301)
@@ -16,12 +16,10 @@
 
 /*DataSetParam constructors and destructor*/
-/*FUNCTION DataSetParam::DataSetParam(){{{*/
-DataSetParam::DataSetParam(){
+DataSetParam::DataSetParam(){/*{{{*/
 	value=NULL;
 	return;
 }
 /*}}}*/
-/*FUNCTION DataSetParam::DataSetParam(int enum_type,DataSet *value){{{*/
-DataSetParam::DataSetParam(int in_enum_type,DataSet* in_value){
+DataSetParam::DataSetParam(int in_enum_type,DataSet* in_value){/*{{{*/
 
 	enum_type=in_enum_type;
@@ -29,6 +27,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSetParam::~DataSetParam(){{{*/
-DataSetParam::~DataSetParam(){
+DataSetParam::~DataSetParam(){/*{{{*/
 	delete value;
 }
@@ -36,11 +33,9 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION DataSetParam::Echo {{{*/
-void DataSetParam::Echo(void){
+void DataSetParam::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION DataSetParam::DeepEcho{{{*/
-void DataSetParam::DeepEcho(void){
+void DataSetParam::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(22)<<"   DataSetParam "<<setw(35)<<left<<EnumToStringx(this->enum_type)<<" ----- begin\n");
@@ -49,9 +44,7 @@
 }
 /*}}}*/
-/*FUNCTION DataSetParam::Id{{{*/
-int    DataSetParam::Id(void){ return -1; }
+int    DataSetParam::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION DataSetParam::ObjectEnum{{{*/
-int DataSetParam::ObjectEnum(void){
+int DataSetParam::ObjectEnum(void){/*{{{*/
 
 	return DataSetParamEnum;
@@ -59,6 +52,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSetParam::copy{{{*/
-Object* DataSetParam::copy() {
+Object* DataSetParam::copy() {/*{{{*/
 
 	return new DataSetParam(this->enum_type,this->value);
@@ -68,6 +60,5 @@
 
 /*DataSetParam virtual functions definitions: */
-/*FUNCTION DataSetParam::GetParameterValue{{{*/
-void DataSetParam::GetParameterValue(DataSet** pdataset){
+void DataSetParam::GetParameterValue(DataSet** pdataset){/*{{{*/
 	*pdataset=value->Copy();
 }
